<id>
BoardSort Previous/Next Plus
</id>

<version>
1.0rc1
</version>

<mod info>
Note: BoardSort Previous/Next Plus requires that BoardSort-2.0rc1 (or later) already be installed!

This mod enhances the previous/next links at the top of threads and is based on the very cool "prev_next_plus.mod" by Ronnie.

Here's what it does:
 - Instead of "Previous topic" and "Next topic", the link names are the (abbreviated, if necessary, to the first 20 characters) titles of those topics
 - Previous and next topics are marked as being "new" when appropriate
 - Clicking on a previous/next link takes you to the last post of that topic rather than the first
 - There is an "Index" link in between to quickly jump back to the message index

Install using BoardMod, and upload these 2 files that are changed:
  Sources/Display.pl
  english.lng

Finally, transfer 'prev_new_plus.gif', 'next_new_plus.gif', 'prev_plus.gif', 'next_plus.gif' and 'up_plus.gif' (located in the "BoardSort-PrevNextPlus Images" folder) to your YaBBImages directory.

Tested on YaBB 1 Gold - SP 1.3.1, but also applies cleanly on SP 1.4 (although not tested).
</mod info>

<author>
EddyG
</author>

<homepage>
http://www.boardmod.org
</homepage>

<edit file>
Sources/Display.pl
</edit file>

<search for>
	my $found;
	my $name = $INFO{'num'};
	my $bcount = 0;
	$CurrentPosition = -1;
	foreach $ThreadNum (@boardtopics) {
		++$CurrentPosition;
		if ($ThreadNum =~ m/\A$name/o) { $found = 1; last; }
	}
	$previous = $boardtopics[$CurrentPosition-1];
	$next = $boardtopics[$CurrentPosition+1];
	@prevthread = split(/\|/, $previous);
	$goprevious = $prevthread[0];
	@nextthread = split(/\|/, $next);
	$gonext = $nextthread[0];
	@getlastthread = @boardtopics;
	$lastthread = pop(@getlastthread);
	@lasttopic = split(/\|/, $lastthread);
	$endthread2 = $lasttopic[0];
	if($found) {
		$prevtopic = "$cgi;action=display;num=$goprevious";
		$nexttopic = "$cgi;action=display;num=$gonext";
		$endthread = "$cgi;action=display;num=$endthread2";
	}
	if( $endthread eq $prevtopic && $gonext eq "") { $nav = qq~&#171; $txt{'766'} | $txt{'766'} &#187;~; }
	if($endthread eq $prevtopic && $gonext ne "") { $nav = qq~&#171; $txt{'766'} | <a href="$nexttopic">$txt{'767'}</a> &#187;~; }
	if ( $endthread ne $prevtopic && $gonext eq "") { $nav = qq~&#171; <a href="$prevtopic">$txt{'768'}</a> | $txt{'766'} &#187;~; }
	if ($endthread ne $prevtopic && $gonext ne "") { $nav = qq~&#171; <a href="$prevtopic">$txt{'768'}</a> | <a href="$nexttopic">$txt{'767'}</a> &#187;~; 	}
</search for>

<replace>
	# find out where in the (sorted) list the current thread is located
	my $currthread = 0;
	my $thread;
	foreach $thread (@boardtopics) {
	    last if ($thread =~ m/^$viewnum\|/o);
	    $currthread++;
	}

	# is there a valid previous or next thread to link to?
	$previouspos = ($currthread - 1 >= 0) ? $currthread - 1 : -1;
	$nextpos = ($currthread + 1 <= $#boardtopics) ? $currthread + 1 : -1;

	# construct previous link
	if ($previouspos >= 0) {
		my ($previd, $prevtitle, undef, undef, $prevdate) = split(/\|/, $boardtopics[$previouspos]);

		# should we abbreviate the thread title?
		my $shortprevtitle = length($prevtitle) > 20 ? substr($prevtitle, 0, 20) . '&hellip;' : $prevtitle;

		# have the link jump to the last page of the thread
		fopen(FILE, "$datadir/$previd.txt");
		my $num_posts = -1;
		while (<FILE>) {
		    $num_posts++;
		}
		fclose(FILE);

		# check if the previous thread is new
		my $threaddate = stringtotime($prevdate);
		my $prevnew = ( $max_log_days_old && &getlog($previd) < $threaddate && $username ne 'Guest' && &getlog("$INFO{'board'}--mark") < $threaddate ) ? 'prev_new_plus' : 'prev_plus';
		$previouslink = qq~<a href="$cgi;action=display;num=$previd;start=$num_posts#$num_posts" title="$txt{'768'}: $prevtitle">$img{$prevnew}&nbsp;$shortprevtitle</a>~;
	} else {
	       	$previouslink = "$txt{'766'}";
	}
	
	# construct next link
	if ($nextpos > 0) {
		my ($nextid, $nexttitle, undef, undef, $nextdate) = split(/\|/, $boardtopics[$nextpos]);

		# should we abbreviate the thread title?
		my $shortnexttitle = length($nexttitle) > 20 ? substr($nexttitle, 0, 20) . '&hellip;' : $nexttitle;

		# have the link jump to the last page of the thread
		fopen(FILE, "$datadir/$nextid.txt");
		my $num_posts = -1;
		while (<FILE>) {
		    $num_posts++;
		}
		fclose(FILE);
		
		# check if the previous thread is new
		my $threaddate = stringtotime($nextdate);
		my $nextnew = ( $max_log_days_old && &getlog($nextid) < $threaddate && $username ne 'Guest' && &getlog("$INFO{'board'}--mark") < $threaddate ) ? 'next_new_plus' : 'next_plus';
		$nextlink = qq~<a href="$cgi;action=display;num=$nextid;start=$num_posts#$num_posts" title="$txt{'767'}: $nexttitle">$shortnexttitle&nbsp;$img{$nextnew}</a>~;
	} else {
		$nextlink = "$txt{'766'}";
	}

	$nav = qq~$previouslink&nbsp;|&nbsp;<a href="$cgi" title="$prevnextplus{'1'} $boardname $txt{'18'}">$txt{'18'}&nbsp;$img{'up_plus'}</a>&nbsp;|&nbsp;$nextlink~;

</replace>

<edit file>
english.lng
</edit file>

<search for>
$txt{'800'} = "Other";
</search for>

<add after>

$prevnextplus{'1'} = "Jump to";
</add after>

<search for>
if($MenuType == 1) {
</search for>

<add after>
        $img{'prev_plus'} = qq~<font size="1" class="imgbg">&laquo;-</font>~;
        $img{'prev_new_plus'} = qq~<font size="1" class="imgbg">$txt{'302'}&nbsp;&laquo;-</font>~;
        $img{'next_plus'} = qq~<font size="1" class="imgbg">-&raquo;</font>~;
        $img{'next_new_plus'} = qq~<font size="1" class="imgbg">-&raquo;&nbsp;$txt{'302'}</font>~;
        $img{'up_plus'} = qq~<font size="1" class="imgbg">^</font>~;
</add after>

<search for>
}
else {
</search for>

<add after>
        $img{'prev_plus'} = qq~<img src="$imagesdir/prev_plus.gif" border="0" alt="&laquo;-">~;
        $img{'prev_new_plus'} = qq~<img src="$imagesdir/prev_new_plus.gif" border="0" alt="$txt{'302'} &laquo;-">~;
        $img{'next_plus'} = qq~<img src="$imagesdir/next_plus.gif" border="0" alt="-&raquo;">~;
        $img{'next_new_plus'} = qq~<img src="$imagesdir/next_new_plus.gif" border="0" alt="-&raquo; $txt{'302'}">~;
        $img{'up_plus'} = qq~<img src="$imagesdir/up_plus.gif" border="0" alt="^">~;
</add after>
